Subject: bug#75964: Switching the Emacs build to -Wswitch-enum in src/

From: Eli Zaretskii <[email-masked]>
Date: Thu, 06 Feb 2025 10:17:38 +0200

> From: Stefan Kangas <[email-masked]>
> Date: Wed, 5 Feb 2025 14:20:12 -0800
> Cc: [email-masked], [email-masked]
> 
> Paul Eggert <[email-masked]> writes:
> 
> >> I very much doubt these techniques will make our situation
> >> significantly better, if at all.
> >
> > Admittedly Emacs has more serious bugs than enum mismatches. However,
> > checking these mismatches can help find mistakes or help clarify code.
> 
> We had Bug#75712, for example, which I believe Pip Cet found by enabling
> -Wswitch-enum.  It would be nice to catch such bugs statically.

It IMO is okay to use special GCC switches for hunting hidden bugs,
but that doesn't mean we need to use those switches by default,
especially if that requires us to make problematic changes to our
code.  Please don't forget that many people who track the development
branches are not themselves Emacs developers.

We could have a special non-default configure option for adding
"noisy" warning options; many projects do that.